import { Component, Input, Output, EventEmitter } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { AuthService } from '@services/auth.service';

@Component({
  selector: 'app-sidebar',
  templateUrl: './sidebar.component.html',
  styleUrl: './sidebar.component.css'
})
export class SidebarComponent {
  @Input() isVisible: boolean = false;
  @Input() sidebarMode: 'side' | 'over' = 'side';
  @Output() closeSidebar: EventEmitter<void> = new EventEmitter<void>();

  username: string | null = "";
  showOgBootSub: boolean = false;
  showOgDhcpSub: boolean = false;
  showCommandSub: boolean = false;
  showSoftwareSub: boolean = false;

  toggleOgBootSub() {
    this.showOgBootSub = !this.showOgBootSub;
  }
  toggleOgDhcpSub() {
    this.showOgDhcpSub = !this.showOgDhcpSub;
  }
  toggleCommandSub() {
    this.showCommandSub = !this.showCommandSub;
  }
  toggleSoftwareSub() {
    this.showSoftwareSub = !this.showSoftwareSub;
  }

  onItemClick() {
    if (this.isVisible && this.sidebarMode === 'over') {
      this.closeSidebar.emit();
    }
  }

  constructor(public dialog: MatDialog, public auth: AuthService,) {}

  ngOnInit(): void {
    this.username = this.auth.username
  }
}